const system = require("../../../system");
const ServiceBase = require("../../sve.base");
class OrderInfoService extends ServiceBase {
  constructor() {
      super("dbcorder", ServiceBase.getDaoName(OrderInfoService));
  }

  async getOrderInfo(pobj, actionBody) {//获取订单列表信息
    var pageSize = Number(actionBody.pageSize || 20);
    if (pageSize > 50) {
      pageSize = 50;
    }
    var pageIndex = Number(actionBody.pageIndex || 1);
    var from = pageIndex == 1 ? 0 : Number((pageIndex - 1) * pageSize);

    var paramWhere = {};
    // var sql = "select `isSolution`,`orderNo`,`channelServiceNo`,`channelOrderNo`,`channelUserId`,`ownerUserId`,`payTime`,`quantity`,`serviceQuantity`,`orderStatusName`,`orderStatus`,`totalSum`,`payTotalSum`,`refundSum`,"
    //   + " `invoiceApplyStatus`,`opNotes`,`channelItemCode`,`channelItemName`,`price`,priceDesc,priceTypeName,channelItemAppendName,`serviceItemCode`,`picUrl`,created_at from v_order where uapp_id=:uapp_id";
    // var sqlCount = "select count(1) as dataCount from v_order where uapp_id=:uapp_id";
    var sql = "select `orderNo`,`channelUserId`,`payTime`,`orderStatusName`,`orderStatus`,`totalSum`,`payTotalSum`,`refundSum`,`refundTime`,"
      + " `channelItemCode`,`channelItemName`,`price`,priceDesc,priceTypeName,`serviceItemCode`,`picUrl`,`created_at`,`updated_at` from v_order where uapp_id=:uapp_id";
    var sqlCount = "select count(1) as dataCount from v_order where uapp_id=:uapp_id";

    paramWhere.uapp_id = pobj.appInfo.uapp_id;

    if (actionBody.orderStatus) {
      sql += " and orderStatus=:orderStatus";
      sqlCount += " and orderStatus=:orderStatus";
      paramWhere.orderStatus = actionBody.orderStatus;
    }
    if (actionBody.startTime && actionBody.entTime) {
      var startTime = actionBody.startTime.trim() + " 00:00:00";
      var entTime = actionBody.entTime + " 23:59:59";
      sql += " and updated_at >=:startTime and  updated_at<=:entTime";
      sqlCount += " and updated_at >=:startTime and  updated_at<=:entTime";
      paramWhere.startTime = startTime;
      paramWhere.entTime = entTime;
    }

    sql += " order by id desc LIMIT " + pageSize + " OFFSET " + from;
 
    var list = await this.customQuery(sql, paramWhere);
    var result = system.getResultSuccess(list);

    var tmpResultCount = await this.customQuery(sqlCount, paramWhere);

    result.dataCount = tmpResultCount && tmpResultCount.length > 0 ? tmpResultCount[0].dataCount : 0;

    return result;

  }
}
module.exports = OrderInfoService;
